unit U_YarnInList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit, cxPC,
  cxLookAndFeels, cxLookAndFeelPainters, cxNavigator, dxDateRanges,Clipbrd,
  dxBarBuiltInMenu, U_BaseList, dxScrollbarAnnotations, cxContainer, dxCore,
  cxDateUtils, cxMaskEdit, FrameDateSel, U_InputBoxSingleNumber, dxSkinsCore,
  dxSkinsDefaultPainters, cxProgressBar, dxSkinOffice2013White, dxSkinSharpPlus,
  dxSkinWXI;

type
  TfrmYarnInList = class(TfrmBaseList)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DS_1: TDataSource;
    GPM_1: TcxGridPopupMenu;
    CDS_Main: TClientDataSet;
    TBDel: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    Label3: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    Label12: TLabel;
    Y_Name: TcxTextEdit;
    FromCoName: TcxTextEdit;
    Y_Composition: TcxTextEdit;
    Label10: TLabel;
    BatchNo: TcxTextEdit;
    ToolButton1: TToolButton;
    Label6: TLabel;
    BYIOID: TcxTextEdit;
    ToolButton2: TToolButton;
    Label5: TLabel;
    Y_Color: TcxTextEdit;
    Frame11: TfrmFrameDateSel;
    IOType: TcxComboBox;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    Y_Code: TcxTextEdit;
    Label1: TLabel;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    Tv1Column9: TcxGridDBColumn;
    v1BYIOID: TcxGridDBColumn;
    Tv1ioTime: TcxGridDBColumn;
    Tv1IOType: TcxGridDBColumn;
    Tv1FromCoName: TcxGridDBColumn;
    Tv1StkCoName: TcxGridDBColumn;
    Tv1Y_Code: TcxGridDBColumn;
    Tv1Y_Name: TcxGridDBColumn;
    Tv1Y_Composition: TcxGridDBColumn;
    Tv1Y_Color: TcxGridDBColumn;
    Tv1FF: TcxGridDBColumn;
    T1BatchNo: TcxGridDBColumn;
    Tv1Piece: TcxGridDBColumn;
    Tv1SXCBH: TcxGridDBColumn;
    Tv1SXCPM: TcxGridDBColumn;
    Tv1Qty: TcxGridDBColumn;
    Tv1QtyUnit: TcxGridDBColumn;
    Tv1Note: TcxGridDBColumn;
    cxGrid1Level1: TcxGridLevel;
    cxGrid2: TcxGrid;
    Tv2: TcxGridDBTableView;
    cxGridDBColumn1: TcxGridDBColumn;
    Tv2BYIOID: TcxGridDBColumn;
    Tv2ioTime: TcxGridDBColumn;
    Tv2IOType: TcxGridDBColumn;
    Tv2FromCoName: TcxGridDBColumn;
    Tv2StkCoName: TcxGridDBColumn;
    Tv2Y_Code: TcxGridDBColumn;
    Tv2Y_Name: TcxGridDBColumn;
    Tv2Y_Composition: TcxGridDBColumn;
    Tv2Y_Color: TcxGridDBColumn;
    Tv2FF: TcxGridDBColumn;
    Tv2BatchNo: TcxGridDBColumn;
    Tv2Piece: TcxGridDBColumn;
    Tv2SXCBH: TcxGridDBColumn;
    Tv2SXCPM: TcxGridDBColumn;
    Tv2Qty: TcxGridDBColumn;
    Tv2QtyUnit: TcxGridDBColumn;
    Tv2Note: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    GPM_2: TcxGridPopupMenu;
    CDS_Main_Del: TClientDataSet;
    DS_2: TDataSource;
    ADOQueryMain_Del: TADOQuery;
    Tv1FromPurNo: TcxGridDBColumn;
    Tv1FromConNo: TcxGridDBColumn;
    Tv1Denier: TcxGridDBColumn;
    Tv1ZS: TcxGridDBColumn;
    Tv1dbWeight: TcxGridDBColumn;
    Tv1dbNumber: TcxGridDBColumn;
    Tv1singleWeight: TcxGridDBColumn;
    Tv2CFromPurNo: TcxGridDBColumn;
    Tv2FromConNo: TcxGridDBColumn;
    Tv2Denier: TcxGridDBColumn;
    Tv2ZS: TcxGridDBColumn;
    Tv2dbWeight: TcxGridDBColumn;
    Tv2dbNumber: TcxGridDBColumn;
    Tv2singleWeight: TcxGridDBColumn;
    Label2: TLabel;
    Label7: TLabel;
    FromPurNo: TcxTextEdit;
    FromConNo: TcxTextEdit;
    N3: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure BYIOIDChange(Sender: TObject);
    procedure Y_specChange(Sender: TObject);
    procedure FromCoNameChange(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure BYIOIDKeyPress(Sender: TObject; var Key: Char);
    procedure N3Click(Sender: TObject);
  private
    canshu1, FStkName, canshu3: string;
    procedure InitGrid();
    procedure setStatus();
    procedure InitDelGrid();
    { Private declarations }
  public

    { Public declarations }
  end;

implementation

uses
  U_DataLink, U_RTFun, U_YarnInEdit, U_LabelPrint, U_YarnOutReturnList,
  U_YarnOutReturnList1, U_AttachmentUpload, U_CJDJ;

{$R *.dfm}
procedure TfrmYarnInList.setStatus();
begin

end;

procedure TfrmYarnInList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmYarnInList.FormCreate(Sender: TObject);
begin
  inherited;
  Frame11.EndDate.Date := SGetServerDate(ADOQueryTemp);
  Frame11.BegDate.Date := Frame11.EndDate.Date - 30;

  canshu1 := Trim(self.fParameters1);
  FStkName := Trim(self.fParameters2);
  canshu3 := Trim(self.fParameters3);
end;

procedure TfrmYarnInList.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;
      sql.Add(' select A.* ');

      sql.Add(',Case when ISnull(CJDate,'''') <> '''' ');
      sql.Add('then Cast(1 as bit) else Cast(0 as bit) end as ISCJ');

      sql.Add(',Case when isnull((select count(*) from FJ_File where WBID=A.BYIOID and TFType=''纱线'' ),0)>0 ');
      sql.Add('then Cast(1 as bit) else Cast(0 as bit) end as FJFlag');

      sql.Add(' from BS_Yarn_IO A');
      sql.add(' where A.IOTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', Frame11.BegDate.Date)) + '''');
      sql.Add(' and A.IOTime<''' + Trim(FormatDateTime('yyyy-MM-dd', Frame11.enddate.Date + 1)) + '''');
      sql.Add(' and isnull(StkName,'''')=''' + Trim(FStkName) + '''');
      SQL.Add(' and IOFlag=''入库''  ');
      SQL.Add(' order by IOTime desc');
      Open;
    end;
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS(ADOQueryMain, CDS_Main);
    SInitCDSData(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmYarnInList.InitDelGrid();
begin
  try
    ADOQueryMain_Del.DisableControls;
    with ADOQueryMain_Del do
    begin
      Filtered := False;
      Close;
      sql.Clear;
      sql.Add(' select A.* ');

      sql.Add(',Case when ISnull(CJDate,'''') <> '''' ');
      sql.Add('then Cast(1 as bit) else Cast(0 as bit) end as ISCJ');

      sql.Add(',Case when isnull((select count(*) from FJ_File where WBID=A.BYIOID and TFType=''纱线'' ),0)>0 ');
      sql.Add('then Cast(1 as bit) else Cast(0 as bit) end as FJFlag');

      sql.Add(' from BS_Yarn_IO_Del A');
      sql.add(' where A.IOTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', Frame11.BegDate.Date)) + '''');
      sql.Add(' and A.IOTime<''' + Trim(FormatDateTime('yyyy-MM-dd', Frame11.enddate.Date + 1)) + '''');
      sql.Add(' and isnull(StkName,'''')=''' + Trim(FStkName) + '''');
      SQL.Add(' and IOFlag=''入库''  ');
      SQL.Add(' order by IOTime desc');
      Open;
    end;
    SDofilter(ADOQueryMain_Del, SGetFilters(Panel1, 1, 2));
    SCreateCDS(ADOQueryMain_Del, CDS_Main_Del);
    SInitCDSData(ADOQueryMain_Del, CDS_Main_Del);
  finally
    ADOQueryMain_Del.EnableControls;
  end;
end;

procedure TfrmYarnInList.TBRafreshClick(Sender: TObject);
begin
  ToolBar1.SetFocus;
  InitGrid();
  InitDelGrid();
end;

procedure TfrmYarnInList.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(Self.Caption + '2', Tv1, '纱线仓库');
end;

procedure TfrmYarnInList.ToolButton2Click(Sender: TObject);
var
  MBYIOID: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;

  MBYIOID := '';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin

      MBYIOID := MBYIOID + ',' + (Trim(CDS_Main.fieldbyname('BYIOID').AsString));

      Edit;
      FieldByName('SSel').Value := False;
      Post;
    end;
  end;
  CDS_Main.EnableControls;

  try
    frmLabelPrint := TfrmLabelPrint.Create(Application);
    with frmLabelPrint do
    begin
      FLMType := 'BSYarnInPrt1';
      FFiltration1 := MBYIOID;
      if ShowModal = 1 then
      begin
//        Self.InitGrid();
      end;
    end;
  finally
    frmLabelPrint.Free;
  end;
end;

procedure TfrmYarnInList.ToolButton3Click(Sender: TObject);
var
  MBYIOIDs: string;
begin
  MBYIOIDs := SelCDSKey(CDS_Main, ['BYIOID'])[0];
  if MBYIOIDs = '' then
    Exit;

  try
    frmInputBoxSingleNumber := TfrmInputBoxSingleNumber.Create(Application);
    with frmInputBoxSingleNumber do
    begin
      if ShowModal = 1 then
      begin
        if StrToFloatDef(frmInputBoxSingleNumber.Price.Text, 0) = 0 then
          frmInputBoxSingleNumber.Price.Text := '0';

        try
          ADOQueryCmd.Connection.BeginTrans;
          with ADOQueryCmd do
          begin
            Close;
            Sql.Clear;
            Sql.Add('update BS_Yarn_IO set TestDenier=' + frmInputBoxSingleNumber.Price.Text);
            sql.Add('where EXISTS(select X.RTValue from [dbo].[F_Tool_SplitString](' + quotedstr(MBYIOIDs) + ','','') X where BS_Yarn_IO.BYIOID=X.RTValue )  ');
            ExecSQL;
          end;

          with ADOQueryCmd do
          begin
            Close;
            sql.Clear;
            sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
            sql.Add(' ' + quotedstr(trim(DName)));
            sql.Add(',getdate() ');
            sql.Add(',' + quotedstr(trim(self.Caption)));
            sql.Add(',' + quotedstr(trim('D数调整')));
            sql.Add(',' + quotedstr(trim(MBYIOIDs) + '   D数：' + frmInputBoxSingleNumber.Price.Text));
            sql.Add(',' + quotedstr(trim('成功')));
            sql.Add(')');
            ExecSQL;
          end;
          ADOQueryCmd.Connection.CommitTrans;

        except
          ADOQueryCmd.Connection.RollbackTrans;
          application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
        end;
      end;
    end;
  finally
    frmInputBoxSingleNumber.Free;
  end;
  InitGrid();
end;

procedure TfrmYarnInList.ToolButton4Click(Sender: TObject);
begin
  try
    frmYarnOutReturnList := TfrmYarnOutReturnList.Create(Application);
    with frmYarnOutReturnList do
    begin
      FStkName := Self.FStkName;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmYarnOutReturnList.Free;
  end;
end;

procedure TfrmYarnInList.ToolButton5Click(Sender: TObject);
begin
  try
    frmYarnOutReturnList1 := TfrmYarnOutReturnList1.Create(Application);
    with frmYarnOutReturnList1 do
    begin
      FStkName := Self.FStkName;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmYarnOutReturnList1.Free;
  end;

end;

procedure TfrmYarnInList.ToolButton6Click(Sender: TObject);    //附件
begin
  try
    frmAttachmentUpload := TfrmAttachmentUpload.Create(Application);
    with frmAttachmentUpload do
    begin
      FEditAuthority := True;
      fkeyNO := Trim(CDS_Main.fieldbyname('BYIOID').AsString);
      fType := '纱线';
      if ShowModal = 1 then
      begin

      end;
    end;
  finally
    frmAttachmentUpload.Free;
  end;

end;

procedure TfrmYarnInList.ToolButton7Click(Sender: TObject);   //choujian dengji
var
  MBYIOIDs: string;
begin
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  try
    frmCJDJ := TfrmCJDJ.Create(Application);
    with frmCJDJ do
    begin
      FBYIOID := Trim(CDS_Main.fieldbyname('BYIOID').AsString);
      if ShowModal = 1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmCJDJ.Free;
  end;

end;

procedure TfrmYarnInList.BYIOIDKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
  begin
    TBFind.Click;
  end;

end;



procedure TfrmYarnInList.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmYarnInList.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmYarnInList.FormShow(Sender: TObject);
var
  mSql: string;
begin
  inherited;
  mSql := 'select distinct name=A.IOType from BS_Yarn_IO A where IOFlag=''入库'' and isnull(STKNAME,'''')=''' + Trim(FSTKNAME) + ''' ';
  SInitTcxComBoxBySql(ADOQueryTemp, IOType, false, mSql);
  ReadCxGrid(Self.Caption + '2', Tv1, '纱线仓库');
  setStatus();
  InitGrid();
  InitDelGrid();
end;

procedure TfrmYarnInList.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then
    exit;
  TcxGridToExcel(FStkName + '入库列表', cxGrid1);
end;

procedure TfrmYarnInList.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS(ADOQueryMain, CDS_Main);
    SInitCDSData(ADOQueryMain, CDS_Main);
  end;
  if ADOQueryMain_Del.Active then
  begin
    SDofilter(ADOQueryMain_Del, SGetFilters(Panel1, 1, 2));
    SCreateCDS(ADOQueryMain_Del, CDS_Main_Del);
    SInitCDSData(ADOQueryMain_Del, CDS_Main_Del);
  end;
end;

procedure TfrmYarnInList.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, True);
end;

procedure TfrmYarnInList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, False);
end;

procedure TfrmYarnInList.N3Click(Sender: TObject);
begin
  Clipboard.SetTextBuf(PChar(Trim(CDS_Main.fieldbyname(TV1.Controller.FocusedColumn.DataBinding.FilterFieldName).AsString)));
end;

procedure TfrmYarnInList.TBDelClick(Sender: TObject);
var
  MBYIOID: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  MBYIOID := '';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin

      MBYIOID := MBYIOID + ',' + Trim(CDS_Main.fieldbyname('BYIOID').AsString);
      CDS_Main.Delete;
    end;
  end;
  CDS_Main.EnableControls;

  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('exec P_Fin_Flow_Judge ');
    Sql.Add(' @FFIDS=' + quotedstr(MBYIOID));
    Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
    Sql.Add(',@DName=' + quotedstr(Trim(DName)));
    Open;
  end;
  if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
  begin
    Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
    exit;
  end;

  try
    ADOQueryCmd.Connection.BeginTrans;
    with ADOQueryCmd do
    begin
      Close;
      Sql.Clear;
      sql.Add('insert into Finance_Need_Up(UType,UDataId,UOperation,UOperator,UModule,UDetails)       ');
      sql.Add('values(''纱线入库''    ');
      sql.Add(',' + quotedstr(MBYIOID));
      sql.Add(',''删除''   ');
      sql.Add(',' + quotedstr(DName));
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(MBYIOID));
      sql.Add(')  ');

      Sql.Add('exec P_BS_Yarn_In_Del ');
      Sql.Add(' @BYIOIDS=' + quotedstr(MBYIOID));
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      Open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    ADOQueryCmd.Connection.CommitTrans;
    InitGrid();
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;

end;

procedure TfrmYarnInList.TBAddClick(Sender: TObject);
begin
  try
    frmYarnInEdit := TfrmYarnInEdit.Create(Application);
    with frmYarnInEdit do
    begin
      FBCId := '';
      frmYarnInEdit.canshu3 := Trim(Self.canshu3);
      FStkName := Self.FStkName;

      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmYarnInEdit.Free;
  end;
end;

procedure TfrmYarnInList.TBEditClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('exec P_Fin_Flow_Judge ');
    Sql.Add(' @FFIDS=' + quotedstr(Trim(CDS_Main.fieldbyname('BYIOID').AsString)));
    Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
    Sql.Add(',@DName=' + quotedstr(Trim(DName)));
    Open;
  end;
  if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
  begin
    Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
    exit;
  end;
  with ADOQueryTemp do
  begin
    Close;
    Sql.Clear;
    Sql.Add('exec P_BS_Yarn_In_Edit ');
    Sql.Add(' @BYIOIDS=' + quotedstr(Trim(CDS_Main.fieldbyname('BYIOID').AsString)));
    Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
    Sql.Add(',@DName=' + quotedstr(Trim(DName)));
    Open;
  end;
  if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
  begin
    Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
    exit;
  end;
  try
    frmYarnInEdit := TfrmYarnInEdit.Create(Application);
    with frmYarnInEdit do
    begin
      FBCId := Trim(CDS_Main.fieldbyname('BYIOID').AsString);
      TBDel.Visible := False;
      TBAdd.Visible := False;
      FStkName := Self.FStkName;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmYarnInEdit.Free;
  end;
end;

procedure TfrmYarnInList.BYIOIDChange(Sender: TObject);
begin
  if Length(Trim(BYIOID.Text)) < 4 then
  begin
    if Trim(BYIOID.Text) <> '' then
      Exit;
  end;
  TBFind.Click;
end;

procedure TfrmYarnInList.Y_specChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmYarnInList.FromCoNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmYarnInList.cxTabControl1Change(Sender: TObject);
begin
  InitGrid();
end;

end.

